/*  etseq Ա 
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#ifndef _ETSEQ_APP_APPEARED_
#define _ETSEQ_APP_APPEARED_

#if defined(_DEBUG) && defined(_MSC_VER) && _MSC_VER < 1300
#pragma warning (disable: 4503)
#pragma warning (disable: 4786)
#endif

#include "cross.h"
#include <set>
#include <iostream>
#include <cstdlib>
#include <cassert>
#if defined(UNIX) || defined(LINUX)
#include <signal.h>
#endif
#include "etseq_ctrl.h"
#include "etseq_srv.h"
#include "config_file.h"
#include "fileutil.h"
#include "trace.h"

namespace etseq
{

//  Unix/Linux £ _USE_SIGNAL ꣬
// ó SIGINT źţ SIGINT źŵʱ˳
#if defined(UNIX) || defined(LINUX)
#ifdef _USE_SIGNAL
void do_nothing(int);
#endif

//  SIGTERM źţֹΪ broken pipe ˳
void broken_pipe(int);
extern volatile bool pipe_flag;

#ifdef _USE_RELOAD
void on_hup(int);
extern volatile bool hup_flag;
#endif

#endif

// ȫӦó
class etseq_base
{
public:
    etseq_base(void);
    virtual ~etseq_base(void);

public:
    virtual int run(int argc, char *argv[]) = 0;
};

// ȫַʹ Thread Ϊ̣߳
// ʹ Configuration Ϊļ
// Thread Ҫ̳ euc::thread ʵ
// static unsigned get_default_port(void)
// طĬ϶˿ںţ
// Ƽ̳ etseq::etseq_srv ࡣ
// Configuration Ҫʵһ std::string Ĺ캯
// ĳҪļ֧֣
// ֱʹ std::string Ϊģ
template <class Thread, class Configuration = euc::config_file>
class etseq_app : public etseq_base
{
public:
    // һ etseq_app Ϊ appname
    //  appname Ϊ NULLʹóļΪ appname
    //  Windows ƽ̨µĻȥ.exe
    etseq_app(const char *const appname);
    // һ etseq_app Ϊ appname
    //  appname Ϊ ""ʹóļΪ appname
    //  Windows ƽ̨µĻȥ.exe
    etseq_app(const std::string appname = std::string());
    virtual ~etseq_app(void);

public:
    // ڵ㣬дúʵܡ
    virtual int run(int argc, char *argv[]);

    // Ӧóơ⺬壬
    // ҪظúϢ
    virtual std::string get_app_name(void) const;
    // ļ·ظú¶ļļ
    // úĬϰ汾ǣ
    //  get_app_name ȡӦóƣ
    //  Unix/Linux ƽ̨£Ӧóǰӵ㡰.
    // ûĿ¼´ļ
    //  Windows ƽ̨£Ӧóƺӡ.ini
    // ڳ·´ļ
    virtual std::string get_config_filename(void) const;
    // ȡļ
    virtual Configuration &get_config(void) const;
    //  true ͬ addr 
    //  false ɻؾ addr 
    // Ŀģ벻Ҫظú
    // ʵ IP  etseq_ctrl::connection_allowed
    bool connection_allowed(sockaddr_in *addr, SOCKET sock) const;

protected:
    // ʼӦó
    virtual bool initialize(void);
    // Ӧó
    virtual bool clean_up(void);
    // ȴ÷ɺ block ״̬
    //  block غ󣬷йرպ
    // ظúʹϣʱء
    // δ _USE_SIGNAL
    // úĬϰ汾Ļʾ
    // Type "quit" and press enter to exit:
    //  quit سúء
    //  _USE_SIGNAL
    // Unix/Linux ½ȴ SIGINT źţƼʹã
    // Windows ½ȴ WM_USER + 1000 ߳ϢƺȽûе
    virtual bool block(void) const;
#ifdef _USE_RELOAD
    // ʱ¼ļ
    // ʹøùҪ _USE_RELOAD ꣬
    // ظúʵ¼ļĹܡ
    //  Unix/Linux µȴ SIGHUP źţ
    // Windows µȴ WM_USER + 1001 ߳Ϣ
    virtual bool reload(void) const = 0;
#endif

private:
    std::string _appname;
    Configuration *_config;
};

template <class Thread, class Configuration>
etseq_app<Thread, Configuration>::etseq_app(const char *const appname)
    : _appname(appname), _config(NULL)
{}

template <class Thread, class Configuration>
etseq_app<Thread, Configuration>::etseq_app(const std::string appname)
    : _appname(appname), _config(NULL)
{}

template <class Thread, class Configuration>
etseq_app<Thread, Configuration>::~etseq_app(void)
{}

template <class Thread, class Configuration>
int etseq_app<Thread, Configuration>::run(int argc,
                                          char *argv[])
{
    if (_appname.size() == 0)
    {
        _appname = euc::getfilename(argv[0]);
#ifdef WIN32
        _appname = _appname.substr(0, _appname.find_last_of('.'));
#endif
    }

    // ûиóʱ˲ʹøòΪļ
    //  get_config_filename 
    if (argc > 1)
        _config = new Configuration(argv[1]);
    else
        _config = new Configuration(get_config_filename());

#ifndef _NO_CONSOLE
    std::cout << "Starting server . . ." << std::endl;
#endif
    if (!initialize())
    {
#ifndef _NO_CONSOLE
        std::cout << "Initializing failed!" << std::endl;
#endif
        delete _config;
        return 1;
    }

    // ʹ״̬
    // һӵж
    etseq_ctrl<Thread, Configuration> *_control;
    unsigned localport = Thread::get_default_port();
    _control = new etseq_ctrl<Thread, Configuration>(localport, this);

    if (_control->initialize())
    {
#ifndef _NO_CONSOLE
        std::cout << "Listening on port " << localport
            << "." << std::endl;
        std::cout << "Server started." << std::endl;
#endif
    }
    else
    {
#ifndef _NO_CONSOLE
        std::cout << "Binding port failed." << std::endl;
#endif
        delete _config;
        return 1;
    }

    _control->start();
    block();
    _control->stop();
    _control->wait();

    if (!clean_up())
    {
#ifndef _NO_CONSOLE
        std::cout << "Clean up failed!" << std::endl;
#endif
        delete _control;
        delete _config;
        return 2;
    }

    delete _control;
    delete _config;

#ifndef _NO_CONSOLE
    std::cout << "Server stopped." << std::endl;
#endif
    return 0;
}

template <class Thread, class Configuration>
bool etseq_app<Thread, Configuration>::initialize(void)
{
    trace("Server initialized!\n");
    return true;
}

template <class Thread, class Configuration>
bool etseq_app<Thread, Configuration>::clean_up(void)
{
    trace("Server stopped!\n");
    return true;
}

template <class Thread, class Configuration>
bool etseq_app<Thread, Configuration>::block(void) const
{
    trace("Server started . . .\n");
    std::string cmd;

#if defined(UNIX) || defined(LINUX)
    signal(SIGPIPE, broken_pipe);
#endif
#ifdef _USE_SIGNAL
#if defined(UNIX) || defined(LINUX)
    signal(SIGTERM, do_nothing);
    signal(SIGINT, do_nothing);

#ifdef _USE_RELOAD
    signal(SIGHUP, on_hup);
#endif

    do
    {
        pipe_flag = false;
#ifdef _USE_RELOAD
        hup_flag = false;
#endif
        pause();
#ifdef _USE_RELOAD
        if (hup_flag)
            reload();
#endif
    }
    while (pipe_flag);
#ifndef _NO_CONSOLE
    std::cout << std::endl;
#endif
#else
    MSG msg;
    do
    {
        GetMessage(&msg, NULL, 0, 0);
#ifdef _USE_RELOAD
        if (msg.message == WM_USER + 1001)
            reload();
#endif
    }
    while (msg.message != WM_USER + 1000);
#endif
#else
    do
    {
#ifndef _NO_CONSOLE

#ifdef _USE_RELOAD
        std::cout << "Type \"quit\" to exit, type \"reload\" to reload: ";
#else
        std::cout << "Type \"quit\" and press enter to exit: ";
#endif

#endif
        std::cin >> cmd;
#ifdef _USE_RELOAD
        if (cmd == "reload")
            reload();
#endif
    }
    while (cmd != "quit");
#endif

#ifndef _NO_CONSOLE
    std::cout << "Sending stop query, waiting server to die . . ."
        << std::endl;
#endif
    return true;
}

template <class Thread, class Configuration>
std::string etseq_app<Thread, Configuration>::get_app_name(void) const
{
    return _appname;
}

template <class Thread, class Configuration>
std::string etseq_app<Thread, Configuration>::get_config_filename(void) const
{
    std::string result;
#if defined(UNIX) || defined(LINUX)
    result = getenv("HOME");
    if (result[result.size() - 1] != euc::PATH_SEPARATOR)
        result += euc::PATH_SEPARATOR;
#else
    char selfpath[1024];
    GetModuleFileName(GetModuleHandle(NULL), selfpath, 1024);
    result = euc::getpathname(selfpath);
#endif

    std::string filename;
#if defined(UNIX) || defined(LINUX)
    filename = "." + _appname;
#else
    filename = _appname + ".ini";
#endif

    result += filename;
    return result;
}

template <class Thread, class Configuration>
Configuration &etseq_app<Thread, Configuration>::get_config(void) const
{
    return *_config;
}

template <class Thread, class Configuration>
bool etseq_app<Thread, Configuration>::connection_allowed
    (sockaddr_in *addr, SOCKET sock) const
{
    trace("A user mounted from %d.%d.%d.%d!\n",
        ((unsigned char *) &addr->sin_addr)[0],
        ((unsigned char *) &addr->sin_addr)[1],
        ((unsigned char *) &addr->sin_addr)[2],
        ((unsigned char *) &addr->sin_addr)[3]);
    return true;
}

// ȫӦó
extern etseq_base *_app;

} //namespace

#endif
